from CvPythonExtensions import *
from BasicFunctions import *
import PyHelpers

PyPlayer = PyHelpers.PyPlayer
gc = CyGlobalContext()

#Allow adepts with Nature I to clear up goblin waste.
def reqScrubFallout(pCaster):
	pPlot = pCaster.plot()
	if (pPlot.getFeatureType() == gc.getInfoTypeForString('FEATURE_FALLOUT')):
		return True
	return False
	
#Allow adepts with Nature I to clear up goblin waste.
def spellScrubFallout(pCaster):
	pPlot = pCaster.plot()
	pPlot.setFeatureType(-1,0)

#Allow Entropy I adepts to spread Hell Terrain (Requires Ashen Veil religion).
def reqDefile(caster):
	pPlot = caster.plot()
	bValid = False
	if pPlot.getImprovementType() == gc.getInfoTypeForString('IMPROVEMENT_CITY_RUINS'):
		return True
	if pPlot.getImprovementType() == gc.getInfoTypeForString('IMPROVEMENT_GRAVEYARD'):
		return True
	iX = pPlot.getX()
	iY = pPlot.getY()
	getPlot	= CyMap().plot
	plotOwners = []
	if gc.getGame().isOption(GameOptionTypes.GAMEOPTION_NO_PLOT_COUNTER):
		iBrokenLands = gc.getInfoTypeForString('TERRAIN_BROKEN_LANDS')
		iBurningSands = gc.getInfoTypeForString('TERRAIN_BURNING_SANDS')
		iFieldsOfPerdition = gc.getInfoTypeForString('TERRAIN_FIELDS_OF_PERDITION')
		iShallows = gc.getInfoTypeForString('TERRAIN_SHALLOWS')
		bHellTerrain = False
		bNormalTerrain = False
		for iiX,iiY in RANGE1:
			pPlot = getPlot(iX+iiX,iY+iiY)
			if not pPlot.isNone():
				iTerrain = pPlot.getTerrainType()
				if (iTerrain == iBrokenLands or iTerrain == iBurningSands or iTerrain == iFieldsOfPerdition or iTerrain == iShallows):
					bHellTerrain = True
				else:
					bNormalTerrain = True
			if pPlot.isOwned():
				plotOwners.append(pPlot.getOwner())
			if (bHellTerrain and bNormalTerrain):
				bValid = True
	else:
		for iiX,iiY in RANGE1:
			pPlot = getPlot(iX+iiX,iY+iiY)
			if not pPlot.isNone():
				if pPlot.getPlotCounter() > 0 and pPlot.getPlotCounter() < 20:
					bValid = True
				if pPlot.isOwned():
					plotOwners.append(pPlot.getOwner())
	if bValid == False:
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	iTeam = caster.getTeam()
	eTeam = gc.getTeam(iTeam)
	if not pPlayer.isHuman():
		for iOwner in plotOwners:
			if iOwner == caster.getOwner():
				if pPlayer.getCivilizationType() != gc.getInfoTypeForString('CIVILIZATION_INFERNAL'):
					return False
			else:
				iOwnerTeam = gc.getPlayer(iOwner).getTeam()
				if not eTeam.isAtWar(iOwnerTeam):
					return False
	return True

#Allow Entropy I adepts to spread Hell Terrain (Requires Ashen Veil religion).
def spellDefile(caster):
	pPlot = caster.plot()
	iX = pPlot.getX()
	iY = pPlot.getY()
	getPlot	= CyMap().plot
	if pPlot.getImprovementType() == gc.getInfoTypeForString('IMPROVEMENT_CITY_RUINS'):
		pPlot.setImprovementType(-1)
		CyGame().changeGlobalCounter(1)
	if pPlot.getImprovementType() == gc.getInfoTypeForString('IMPROVEMENT_GRAVEYARD'):
		pPlot.setImprovementType(-1)
		CyGame().changeGlobalCounter(1)
		pPlayer = gc.getPlayer(caster.getOwner())
		newUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_PIT_BEAST'), pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.DIRECTION_SOUTH)
	if gc.getGame().isOption(GameOptionTypes.GAMEOPTION_NO_PLOT_COUNTER):
		iBrokenLands = gc.getInfoTypeForString('TERRAIN_BROKEN_LANDS')
		iBurningSands = gc.getInfoTypeForString('TERRAIN_BURNING_SANDS')
		iDesert = gc.getInfoTypeForString('TERRAIN_DESERT')
		iFieldsOfPerdition = gc.getInfoTypeForString('TERRAIN_FIELDS_OF_PERDITION')
		iGrass = gc.getInfoTypeForString('TERRAIN_GRASS')
		iMarsh = gc.getInfoTypeForString('TERRAIN_MARSH')
		iPlains = gc.getInfoTypeForString('TERRAIN_PLAINS')
		iShallows = gc.getInfoTypeForString('TERRAIN_SHALLOWS')
		for iiX,iiY in RANGE1:
			pPlot = getPlot(iX+iiX,iY+iiY)
			if not pPlot.isNone():
				iTerrain = pPlot.getTerrainType()
				if iTerrain == iGrass:
					pPlot.setTerrainType(iBrokenLands, False, False)
				if iTerrain == iDesert:
					pPlot.setTerrainType(iBurningSands, False, False)
				if iTerrain == iPlains:
					pPlot.setTerrainType(iFieldsOfPerdition, False, False)
				if iTerrain == iMarsh:
					pPlot.setTerrainType(iShallows, False, False)
				if pPlot.isOwned():
					startWar(caster.getOwner(), pPlot.getOwner(), WarPlanTypes.WARPLAN_TOTAL)
	else:
		for iiX,iiY in RANGE1:
			pPlot = getPlot(iX+iiX,iY+iiY)
			if pPlot.getPlotCounter() > 0 and pPlot.getPlotCounter() < 20:
				pPlot.changePlotCounter(20)
				if pPlot.isOwned():
					startWar(caster.getOwner(), pPlot.getOwner(), WarPlanTypes.WARPLAN_TOTAL)
# FF: Added by Jean Elcard 14/01/2009 (speed tweak)
		rebuildGraphics()
# FF: End Add